
/* Subroutine */ int de70dc_c(integer *m, integer *n, doublereal *x,
                              doublereal *aw, doublereal *w, doublereal *bk)
{
    /* System generated locals */
    integer aw_dim1, aw_offset, bk_dim1, bk_offset, i__1, i__2;

    /* Local variables */
    static integer j, k, l;
    static doublereal x2;
    static integer np2;

    /* Parameter adjustments */
    bk_dim1 = *m;
    bk_offset = 1 + bk_dim1;
    bk -= bk_offset;
    --w;
    aw_dim1 = *m;
    aw_offset = 1 + aw_dim1;
    aw -= aw_offset;

    /* Function Body */
    np2 = *n + 2;
    x2 = *x + *x;
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
	bk[l + bk_dim1] = 0.f;
/* L5: */
	bk[l + (bk_dim1 << 1)] = 0.f;
    }
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
	k = np2 - j;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
	    w[l] = bk[l + (bk_dim1 << 1)];
	    bk[l + (bk_dim1 << 1)] = bk[l + bk_dim1];
	    bk[l + bk_dim1] = aw[l + k * aw_dim1] - w[l] + bk[l + (bk_dim1 <<
		    1)] * x2;
/* L10: */
	}
/* L15: */
    }
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
	w[l] = aw[l + aw_dim1] * .5 - bk[l + (bk_dim1 << 1)] + bk[l + bk_dim1]
		 * *x;
/* L20: */
    }
    return 0;
} /* de70dc_c */
