
/* Subroutine */ int de70di_c(S_fp f, integer *m, integer *k, integer *iexit,
	doublereal *yx, doublereal *xj0, doublereal *ajk, doublereal *hd4i,
	doublereal *rabc, doublereal *alpn, doublereal *cmar, doublereal *au,
	doublereal *u, doublereal *zfi)
{
    /* System generated locals */
    integer ajk_dim1, ajk_offset, cmar_dim1, cmar_offset, au_dim1, au_offset,
	    u_dim1, u_offset, zfi_dim1, zfi_offset, i__1, i__2;

    /* Local variables */
    static integer i__, j, l, km1, ip1, kp1, kp2, ip2;
    extern /* Subroutine */ int de70dc_c(integer *, integer *, doublereal *,
	    doublereal *, doublereal *, doublereal *), de70dq_c(integer *,
	    integer *, doublereal *, doublereal *, doublereal *);

    /* Parameter adjustments */
    zfi_dim1 = *m;
    zfi_offset = 1 + zfi_dim1;
    zfi -= zfi_offset;
    au_dim1 = *m;
    au_offset = 1 + au_dim1;
    au -= au_offset;
    ajk_dim1 = *m;
    ajk_offset = 1 + ajk_dim1;
    ajk -= ajk_offset;
    --yx;
    u_dim1 = *m;
    u_offset = 1 + u_dim1;
    u -= u_offset;
    cmar_dim1 = *k;
    cmar_offset = 1 + cmar_dim1;
    cmar -= cmar_offset;
    --alpn;
    --rabc;
    --xj0;
    --hd4i;

    /* Function Body */
    km1 = *k - 1;
    kp1 = *k + 1;
    kp2 = *k + 2;
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L10: */
	au[l + au_dim1] = 0.f;
    }
    i__1 = *k;
    for (j = 2; j <= i__1; j += 2) {
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L15: */
	    au[l + au_dim1] -= ajk[l + (j + 1) * ajk_dim1] * rabc[j];
	}
/* L20: */
    }
    if (*k < 3) {
	goto L31;
    }
    i__1 = *k;
    for (j = 3; j <= i__1; j += 2) {
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L25: */
	    au[l + au_dim1] += ajk[l + (j + 1) * ajk_dim1] * rabc[j];
	}
/* L30: */
    }
L31:
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
	au[l + au_dim1] = (yx[l] + com70d_1.hd4 * (ajk[l + ajk_dim1] - ajk[l
		+ (ajk_dim1 << 1)] * .5) + com70d_1.hd2 * au[l + au_dim1]) *
		2.;
	au[l + kp1 * au_dim1] = hd4i[*k] * ajk[l + *k * ajk_dim1];
	au[l + kp2 * au_dim1] = hd4i[kp1] * ajk[l + kp1 * ajk_dim1];
/* L35: */
    }
    i__1 = km1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	ip1 = i__ + 1;
	ip2 = i__ + 2;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L40: */
	    au[l + ip1 * au_dim1] = hd4i[i__] * (ajk[l + i__ * ajk_dim1] -
		    ajk[l + ip2 * ajk_dim1]);
	}
/* L45: */
    }
    if (*iexit == 1) {
	goto L70;
    }
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
	de70dc_c(m, &kp1, &alpn[j], &au[au_offset], &u[j * u_dim1 + 1], &zfi[
		kp2 * zfi_dim1 + 1]);
/* L50: */
    }
    if (*iexit == 2) {
	goto L70;
    }
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
	(*f)(&xj0[j], &u[j * u_dim1 + 1], &zfi[(j + 1) * zfi_dim1 + 1], m);
/* L55: */
    }
    if (*iexit == 3) {
	goto L70;
    }
    de70dq_c(m, k, &zfi[zfi_offset], &cmar[cmar_offset], &ajk[ajk_offset]);
L70:
    return 0;
} /* de70di_c */
