
/* Subroutine */ int de71ds_c(integer *m, integer *k, doublereal *s,
	                      doublereal *z__, doublereal *rab)
{
    /* System generated locals */
    integer z_dim1, z_offset, i__1, i__2, i__3;

    /* Local variables */
    static integer i__, j, l, j1, jn, ip, kp2, ipn;

    /* Parameter adjustments */
    --rab;
    z_dim1 = *m;
    z_offset = 1 + z_dim1;
    z__ -= z_offset;
    --s;

    /* Function Body */
    kp2 = *k + 2;
    ipn = 1;
    i__1 = *k;
    for (i__ = 1; i__ <= i__1; ++i__) {
	jn = kp2 - i__;
	ip = ipn + jn;
	ipn = ip;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L25: */
	    rab[l] = 0.f;
	}
	i__2 = jn;
	for (j = 1; j <= i__2; ++j) {
	    j1 = kp2 - j;
	    --ip;
	    i__3 = *m;
	    for (l = 1; l <= i__3; ++l) {
/* L30: */
		rab[l] += s[ip] * z__[l + j1 * z_dim1];
	    }
/* L35: */
	}
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L40: */
	    z__[l + i__ * z_dim1] = rab[l];
	}
/* L50: */
    }
    return 0;
} /* de71ds_c */
